###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.11 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.Folder
import rfc822_attachment
import rfc822_address
import base_item


add_rfc822_message_redirect = HTMLFile('rfc822_message_add_redirect', globals())
manage_add_rfc822_message_form = HTMLFile('rfc822_message_add', globals())


def manage_add_rfc822_message(self, id, to, sender, reply_to, cc, bcc, newsgroups, body, REQUEST=None):
    "Add an instance of the rfc822_message class"

    self._setObject(id, rfc822_message(id, to, sender, reply_to, cc, bcc, newsgroups, body))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class rfc822_message(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'RFC822Message'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'sender', 'type':'string'},
		#{'id':'to', 'type':'lines'},
		{'id':'reply_to', 'type':'lines'},
		#{'id':'cc', 'type':'lines'},
		#{'id':'bcc', 'type':'lines'},
		{'id':'newsgroups', 'type':'lines'},
		{'id':'body', 'type':'lines'},
		)

	meta_types = (
		{'name':'RFC822Attachment', 'action':'manage_add_rfc822_attachment_form'}
		)

	manage_add_rfc822_attachment_form = rfc822_attachment.manage_add_rfc822_attachment_form
	manage_add_rfc822_attachment = rfc822_attachment.manage_add_rfc822_attachment
	rfc822_attachment_add_redirect = rfc822_attachment.rfc822_attachment_add_redirect

	#manage_add_rfc822_address_form = rfc822_address.manage_add_rfc822_address_form
	#manage_add_rfc822_address = rfc822_address.manage_add_rfc822_address
	#rfc822_address_add_redirect = rfc822_address.rfc822_address_add_redirect	

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add RFC822Attachment',
		 ('manage_add_rfc822_attachment', 'manage_add_rfc822_attachment_form')),
		('Add RFC822Address',
		 ('manage_add_rfc822_address', 'manage_add_rfc822_address_form')),
		('View RFC822Messages',
		 ('',)),
		)

	index_html = HTMLFile('rfc822_message_index', globals())


	def __init__(self, id, to, sender, reply_to, cc,
				 bcc, newsgroups, body):
		"Initialize the class instance"

		self.id = id

		self.sender = sender
		self.reply_to = reply_to

		OFS.Folder.manage_addFolder(self, 'to', title='to')
		OFS.Folder.manage_addFolder(self, 'cc', title='cc')
		OFS.Folder.manage_addFolder(self, 'bcc', title='bcc')

		for address in to:

			rfc822_address.manage_add_message_address(
				self.to, address)

		for address in cc:

			rfc822_address.manage_add_message_address(
				self.cc, address)

		for address in bcc:

			rfc822_address.manage_add_message_address(
				self.bcc, address)


		self.newsgroups = newsgroups
		self.body = body

		self.index_object()


default__class_init__(rfc822_message)
